/*
 * Copyright (c) 2016. José Alberto Martín. jalbertomartinfalcon@gmail.com
 * Este proyecto ha sido realizado con la ayuda de la documentación y código de los proyectos de la
 * Dirección General de la Policía de España. Para más info: https://www.dnielectronico.es/PortalDNIe/
 * Autorizo la difusión del código fuente con fines educativos siempre que se haga referencia al
 * autor bajo los términos generales de la licencia “Academic Free License v.3.0”.
 */

package jamarfal.jalbertomartinfalcon.dnie_express.application;

import android.app.Application;

import jamarfal.jalbertomartinfalcon.dnie_express.logic.DatabaseHelperStorage;
import jamarfal.jalbertomartinfalcon.dnie_express.logic.singleton.StorageSingleton;


/**
 * Created by jamarfal on 28/11/16.
 */

public class BaseApplication extends Application {

    private static BaseApplication baseApplication;

    public static BaseApplication get() {
        return baseApplication;
    }

    @Override
    public void onCreate() {
        super.onCreate();

        baseApplication = this;
        
        StorageSingleton.getInstance().setStorage(new DatabaseHelperStorage(this));
    }
}
