/*
 * Copyright (c) 2016. José Alberto Martín. jalbertomartinfalcon@gmail.com
 * Este proyecto ha sido realizado con la ayuda de la documentación y código de los proyectos de la
 * Dirección General de la Policía de España. Para más info: https://www.dnielectronico.es/PortalDNIe/
 * Autorizo la difusión del código fuente con fines educativos siempre que se haga referencia al
 * autor bajo los términos generales de la licencia “Academic Free License v.3.0”.
 */

package jamarfal.jalbertomartinfalcon.dnie_express.dialog;

import android.app.AlertDialog;
import android.app.Dialog;
import android.app.DialogFragment;
import android.content.Context;
import android.content.DialogInterface;
import android.os.Bundle;
import android.view.View;
import android.widget.EditText;

import jamarfal.jalbertomartinfalcon.dnie_express.CanSelectionActivity;

import butterknife.BindView;
import butterknife.ButterKnife;
import jamarfal.jalbertomartinfalcon.dnie_express.R;


/**
 * Created by jamarfal on 16/11/16.
 */

public class NewCanDialog extends DialogFragment implements DialogInterface.OnClickListener {

    @BindView(R.id.edittext_dialognewcan_cantext)
    EditText canEditText;

    public static final int CAN_LENGTH = 6;
    private OnCompleteListener mOnCompleteListener;
    private View form = null;
    Context context;

    //region OnCompleteListener Interface
    public static interface OnCompleteListener {
        public void onCompleteCan(String canNumber);
    }
    //endregion

    //region DialogFragment methods
    @Override
    public void onAttach(Context context) {
        super.onAttach(context);
        mOnCompleteListener = (OnCompleteListener) context;
        this.context = context;
    }

    @Override
    public Dialog onCreateDialog(Bundle savedInstanceState) {
        form = getActivity().getLayoutInflater().inflate(R.layout.dialog_new_can, null);

        ButterKnife.bind(this, form);

        AlertDialog.Builder builder = new AlertDialog.Builder(getActivity());
        return (builder.setTitle(context.getString(R.string.dialognewcan_new_can_label))
                .setView(form)
                .setPositiveButton(android.R.string.ok, this)
                .setNegativeButton(android.R.string.cancel, null)
                .create());
    }


    public void onClick(DialogInterface dialog, int which) {
        String can = canEditText.getText().toString();
        if (isAvalidCan(can)) {
            mOnCompleteListener.onCompleteCan(can);
        } else {
            ((CanSelectionActivity) context).showSnackBar(getString(R.string.newcandialog_validated_can));
        }

    }

    @Override
    public void onDismiss(DialogInterface unused) {
        super.onDismiss(unused);
    }

    @Override
    public void onCancel(DialogInterface unused) {
        super.onCancel(unused);
    }
    //endregion



    private boolean isAvalidCan(String can) {
        return can.length() == CAN_LENGTH;
    }
}
