/*
 * Copyright (c) 2016. José Alberto Martín. jalbertomartinfalcon@gmail.com
 * Este proyecto ha sido realizado con la ayuda de la documentación y código de los proyectos de la
 * Dirección General de la Policía de España. Para más info: https://www.dnielectronico.es/PortalDNIe/
 * Autorizo la difusión del código fuente con fines educativos siempre que se haga referencia al
 * autor bajo los términos generales de la licencia “Academic Free License v.3.0”.
 */

package jamarfal.jalbertomartinfalcon.dnie_express.logic;

import java.util.Vector;

/**
 * Created by jamarfal on 16/11/16.
 */

public class ArrayStorage implements Storage {

    private Vector<Mrtd> storage;

    public ArrayStorage() {
        this.storage = new Vector<>();

        initializeMockData();
    }

    private void initializeMockData() {
        for (int i = 0; i < 10; i++) {
            Mrtd dni = new Dnie(String.valueOf(i), "Name " + i, "000" + i);
            storage.add(dni);
        }
    }


    @Override
    public void add(Mrtd mrtd) {
        storage.add(mrtd);
    }

    @Override
    public void remove(String can) {
        for (Mrtd mrtd : storage) {
            if (can.equalsIgnoreCase(mrtd.getCan())) {
                storage.remove(mrtd);
            }
        }
    }

    @Override
    public void remove(Mrtd mrtd) {
        storage.remove(mrtd);
    }

    @Override
    public void update(String can) {

    }


    @Override
    public void update(Mrtd mrtd) {

    }

    @Override
    public Mrtd search(String can) {
        return null;
    }
    

    @Override
    public Vector<Mrtd> getAll() {
        return storage;
    }

    @Override
    public int size() {
        return storage.size();
    }
}
