/*
 * Copyright (c) 2016. José Alberto Martín. jalbertomartinfalcon@gmail.com
 * Este proyecto ha sido realizado con la ayuda de la documentación y código de los proyectos de la
 * Dirección General de la Policía de España. Para más info: https://www.dnielectronico.es/PortalDNIe/
 * Autorizo la difusión del código fuente con fines educativos siempre que se haga referencia al
 * autor bajo los términos generales de la licencia “Academic Free License v.3.0”.
 */

package jamarfal.jalbertomartinfalcon.dnie_express.logic;

import android.os.Parcel;
import android.os.Parcelable;

/**
 * Created by jamarfal on 15/11/16.
 */

public class Dnie extends Mrtd implements Parcelable {

    private String surname;
    private String dateOfExpiration;
    private String dateOfBirth;
    private String nationality;
    private String birthPlace;
    private String personalNumber;
    private String address;
    private String city;
    private String province;
    private byte[] personal_image;
    private byte[] sign_image;


    public Dnie(String can, String name, String nif) {
        super(can, name, nif);
    }

    public Dnie(String can, String name, String nif, String surname,
                String dateOfExpiration, String dateOfBirth, String nationality, String birthPlace,
                String personalNumber, String address, String city, String province) {
        super(can, name, nif);
        this.surname = surname;
        this.dateOfExpiration = dateOfExpiration;
        this.dateOfBirth = dateOfBirth;
        this.nationality = nationality;
        this.birthPlace = birthPlace;
        this.personalNumber = personalNumber;
        this.address = address;
        this.city = city;
        this.province = province;
    }

    public Dnie(String can, String name, String nif, String surname, String dateOfExpiration, String dateOfBirth, String nationality, String birthPlace, String personalNumber, String address, String city, String province, byte[] personal_image, byte[] sign_image) {
        super(can, name, nif);
        this.surname = surname;
        this.dateOfExpiration = dateOfExpiration;
        this.dateOfBirth = dateOfBirth;
        this.nationality = nationality;
        this.birthPlace = birthPlace;
        this.personalNumber = personalNumber;
        this.address = address;
        this.city = city;
        this.province = province;
        this.personal_image = personal_image;
        this.sign_image = sign_image;
    }

    public Dnie() {

    }

    //region Getter y Setter
    public String getSurname() {
        return surname;
    }

    public void setSurname(String surname) {
        this.surname = surname;
    }

    public String getDateOfExpiration() {
        return dateOfExpiration;
    }

    public void setDateOfExpiration(String dateOfExpiration) {
        this.dateOfExpiration = dateOfExpiration;
    }

    public String getDateOfBirth() {
        return dateOfBirth;
    }

    public void setDateOfBirth(String dateOfBirth) {
        this.dateOfBirth = dateOfBirth;
    }

    public String getNationality() {
        return nationality;
    }

    public void setNationality(String nationality) {
        this.nationality = nationality;
    }

    public String getBirthPlace() {
        return birthPlace;
    }

    public void setBirthPlace(String birthPlace) {
        this.birthPlace = birthPlace;
    }

    public String getPersonalNumber() {
        return personalNumber;
    }

    public void setPersonalNumber(String personalNumber) {
        this.personalNumber = personalNumber;
    }

    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }

    public String getCity() {
        return city;
    }

    public void setCity(String city) {
        this.city = city;
    }

    public String getProvince() {
        return province;
    }

    public void setProvince(String province) {
        this.province = province;
    }

    public byte[] getPersonal_image() {
        return personal_image;
    }

    public void setPersonal_image(byte[] personal_image) {
        this.personal_image = personal_image;
    }

    public byte[] getSign_image() {
        return sign_image;
    }

    public void setSign_image(byte[] sign_image) {
        this.sign_image = sign_image;
    }

    public boolean hasIncompleteData() {
        return this.nationality == null;
    }
    //endregion

    //region Parclebale Implementation
    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeString(this.surname);
        dest.writeString(this.dateOfExpiration);
        dest.writeString(this.dateOfBirth);
        dest.writeString(this.nationality);
        dest.writeString(this.birthPlace);
        dest.writeString(this.personalNumber);
        dest.writeString(this.address);
        dest.writeString(this.city);
        dest.writeString(this.province);
        dest.writeByteArray(this.personal_image);
        dest.writeByteArray(this.sign_image);
        dest.writeString(this.can);
        dest.writeString(this.name);
        dest.writeString(this.nif);
    }

    protected Dnie(Parcel in) {
        this.surname = in.readString();
        this.dateOfExpiration = in.readString();
        this.dateOfBirth = in.readString();
        this.nationality = in.readString();
        this.birthPlace = in.readString();
        this.personalNumber = in.readString();
        this.address = in.readString();
        this.city = in.readString();
        this.province = in.readString();
        this.personal_image = in.createByteArray();
        this.sign_image = in.createByteArray();
        this.can = in.readString();
        this.name = in.readString();
        this.nif = in.readString();
    }

    public static final Creator<Dnie> CREATOR = new Creator<Dnie>() {
        @Override
        public Dnie createFromParcel(Parcel source) {
            return new Dnie(source);
        }

        @Override
        public Dnie[] newArray(int size) {
            return new Dnie[size];
        }
    };
    //endregion


}
