/*
 * Copyright (c) 2016. José Alberto Martín. jalbertomartinfalcon@gmail.com
 * Este proyecto ha sido realizado con la ayuda de la documentación y código de los proyectos de la
 * Dirección General de la Policía de España. Para más info: https://www.dnielectronico.es/PortalDNIe/
 * Autorizo la difusión del código fuente con fines educativos siempre que se haga referencia al
 * autor bajo los términos generales de la licencia “Academic Free License v.3.0”.
 */

package jamarfal.jalbertomartinfalcon.dnie_express.logic;

import android.content.Context;
import android.content.res.TypedArray;


import jamarfal.jalbertomartinfalcon.dnie_express.R;

import java.io.InputStream;
import java.security.KeyStore;
import java.util.HashSet;

import es.inteco.labs.net.CaCertificatesHandler;

public class MyCaCertificate implements CaCertificatesHandler {

    static private Context myContext;
    static private KeyStore trustKeyStore;
    static private HashSet<String> validCerts;


    public MyCaCertificate(final Context context) throws Exception {
        // Guardamos el contexto
        myContext = context;

        try {
            // Obtenemos el keyStore del archivo indicado
            trustKeyStore = KeyStore.getInstance("BKS", "BC");
            InputStream certCA = myContext.getResources().openRawResource(R.raw.segsocial_04_2016);
            String passwordCA = "";
            trustKeyStore.load(certCA, passwordCA.toCharArray());

            // Obtenemos los hashes de los certificados válidos desde el archivo indicado
            TypedArray trustedHosts = myContext.getResources().obtainTypedArray(R.array.trusted_hosts);
            validCerts = new HashSet<String>();
            for (int i = 0; i < trustedHosts.length(); i++) {
                validCerts.add(trustedHosts.getString(i));
            }

        } catch (Exception e) {
            e.printStackTrace();
            throw e;
        }
    }

    @Override
    public Object getAndroidContext() {
        return myContext;
    }

    public HashSet<String> getValidCertificates() {
        return validCerts;
    }

    public KeyStore getCaKeyStore() {
        return trustKeyStore;
    }
}