/*
 * Copyright (c) 2016. José Alberto Martín. jalbertomartinfalcon@gmail.com
 * Este proyecto ha sido realizado con la ayuda de la documentación y código de los proyectos de la
 * Dirección General de la Policía de España. Para más info: https://www.dnielectronico.es/PortalDNIe/
 * Autorizo la difusión del código fuente con fines educativos siempre que se haga referencia al
 * autor bajo los términos generales de la licencia “Academic Free License v.3.0”.
 */

package jamarfal.jalbertomartinfalcon.dnie_express.logic.singleton;

import jamarfal.jalbertomartinfalcon.dnie_express.logic.Storage;

/**
 * Created by jamarfal on 28/11/16.
 */
public class StorageSingleton {
    private static StorageSingleton ourInstance = new StorageSingleton();

    private Storage storage;

    public static StorageSingleton getInstance() {
        return ourInstance;
    }

    private StorageSingleton() {
    }

    public Storage getStorage() {
        return storage;
    }

    public void setStorage(Storage storage) {
        this.storage = storage;
    }
}
