/*
 * Copyright (c) 2016. José Alberto Martín. jalbertomartinfalcon@gmail.com
 * Este proyecto ha sido realizado con la ayuda de la documentación y código de los proyectos de la
 * Dirección General de la Policía de España. Para más info: https://www.dnielectronico.es/PortalDNIe/
 * Autorizo la difusión del código fuente con fines educativos siempre que se haga referencia al
 * autor bajo los términos generales de la licencia “Academic Free License v.3.0”.
 */

package jamarfal.jalbertomartinfalcon.dnie_express.preferences;

import android.content.Context;
import android.content.SharedPreferences;
import android.preference.PreferenceManager;

/**
 * Created by jamarfal on 30/11/16.
 */

public class DnieExpressPreferences {

    private SharedPreferences sharedPreferences;
    public final static String KEY_PUBLIC_DATA = "public_data";
    public final static String KEY_PERSONAL_DATA = "personal_data";
    public final static String KEY_USER_IMAGE = "user_image";
    public final static String KEY_SIGN_IMAGE = "sign_image";


    public DnieExpressPreferences(Context context) {
        sharedPreferences = PreferenceManager.getDefaultSharedPreferences(context);
    }


    public boolean userHasCheckedPublicData() {
        return sharedPreferences.getBoolean(KEY_PUBLIC_DATA, true);
    }

    public boolean userHasCheckedPersonalData() {
        return sharedPreferences.getBoolean(KEY_PERSONAL_DATA, true);
    }


    public boolean userHasCheckedUserImage() {
        return sharedPreferences.getBoolean(KEY_USER_IMAGE, true);
    }

    public boolean userHasCheckedSignImage() {
        return sharedPreferences.getBoolean(KEY_SIGN_IMAGE, true);
    }
}
